<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Object</title>
</head>
<body>
    <h1>Costruzione di un oggetto in diversi modi</h1>
    <script>
        // Costruire l'oggetto persona tramite una funzione che accetta come parametro il nome
        function createNewPerson(nome){
            // creo un oggetto vuoto
            let obj = {};
            /* assegno il valore della variabile nome
                alla proprietà name creata tramite dot notation 
            */
            obj.name = nome;        //dot notation
            // obj['name']=name;    //bracket notation
            /* creo una funzione che salut la persona e la assegno tramite
                dot notation alla proprietà greeting
            */
            obj.greeting = function(){
                console.log('Ciao ' + obj.name + '!');
            }
            // Come valore di ritorno restituiamo l'oggetto appena creato
            return obj;
        }

        function Person(nome){
            /* utilizzo la keyword this per assegnare il valore della variabile nome
                alla proprietà name creata tramite dot notation 
            */
            this.name = nome;        //dot notation
            /* creo una funzione che saluta la persona e la assegno tramite
                dot notation alla proprietà greeting
            */
            this.greeting = function(){
                console.log('Ciao ' + this.name + '!');
            }
            // Come valore di ritorno viene restituito il this
        }

        function PersonNew(nome){
            /* utilizzo la keyword this per assegnare il valore della variabile nome
                alla proprietà name creata tramite dot notation 
            */
            this.name = nome;        //dot notation
            // Come valore di ritorno viene restituito il this
        }

        /* creo una funzione che saluta la persona e la aggiungiamo
            al prototype di PersonNew
        */
        PersonNew.prototype.greeting = function(){
            console.log('Ciao ' + this.name + '!');
        }

        // creiamo l'oggetto tramite la funzione createNewPerson
        var daniel = createNewPerson('Daniel');
        
        // creiamo l'oggetto tramite la constructor function Person
        // utilizzando l'operatore new
        var marco = new Person('Marco');      

        // creiamo l'oggetto tramite la constructor function PersonNew
        // utilizzando l'operatore new
        // (l'istanza dell'oggetto creato non avrà il metodo greeting)
        var anna = new PersonNew('Anna');

        // eseguiamo la funzione greeting dell'oggetto appena creato
        daniel.greeting(); // 'Ciao Daniel'
        marco.greeting(); // 'Ciao Marco'
        anna.greeting(); // 'Ciao Anna'
    </script>
</body>
</html>